org.springframework.web.servlet.mvc.annotation

## Class AnnotationMethodHandlerExceptionResolver

- java.lang.Object
- - org.springframework.web.servlet.handler.AbstractHandlerExceptionResolver
  - - org.springframework.web.servlet.mvc.annotation.AnnotationMethodHandlerExceptionResolver

- All Implemented Interfaces:
    Ordered, HandlerExceptionResolver

  Deprecated.
  as of Spring 3.2, in favor of `ExceptionHandlerExceptionResolver`

      public class AnnotationMethodHandlerExceptionResolver
      extends AbstractHandlerExceptionResolver

  Implementation of the `HandlerExceptionResolver` interface that handles exceptions through the `ExceptionHandler` annotation.

  This exception resolver is enabled by default in the `DispatcherServlet`.

  Since:
    3.0
  Author:
    Arjen Poutsma, Juergen Hoeller

- - ### Field Summary

    - ### Fields inherited from class org.springframework.web.servlet.handler.AbstractHandlerExceptionResolver

      `logger`

    - ### Fields inherited from interface org.springframework.core.Ordered

      `HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AnnotationMethodHandlerExceptionResolver()` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ModelAndView` | `doResolveException(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex)` Deprecated. Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.
    `protected List<Class<? extends Throwable>>` | `getHandledExceptions(Method method)` Deprecated. Returns all the exception classes handled by the given method.
    `protected Object` | `resolveCommonArgument(MethodParameter methodParameter, NativeWebRequest webRequest, Exception thrownException)` Deprecated. Resolves common method arguments.
    `protected Object` | `resolveStandardArgument(Class<?> parameterType, NativeWebRequest webRequest, Exception thrownException)` Deprecated. Resolves standard method arguments.
    `void` | `setCustomArgumentResolver(WebArgumentResolver argumentResolver)` Deprecated. Set a custom ArgumentResolvers to use for special method parameter types.
    `void` | `setCustomArgumentResolvers(WebArgumentResolver[] argumentResolvers)` Deprecated. Set one or more custom ArgumentResolvers to use for special method parameter types.
    `void` | `setMessageConverters(HttpMessageConverter<?>[] messageConverters)` Deprecated. Set the message body converters to use.

    - ### Methods inherited from class org.springframework.web.servlet.handler.AbstractHandlerExceptionResolver

      `buildLogMessage, getOrder, logException, prepareResponse, preventCaching, resolveException, setMappedHandlerClasses, setMappedHandlers, setOrder, setPreventResponseCaching, setWarnLogCategory, shouldApplyTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AnnotationMethodHandlerExceptionResolver

          public AnnotationMethodHandlerExceptionResolver()

      Deprecated.

  - ### Method Detail

    - #### setCustomArgumentResolver

          public void setCustomArgumentResolver(WebArgumentResolver argumentResolver)

      Deprecated.
      Set a custom ArgumentResolvers to use for special method parameter types.

      Such a custom ArgumentResolver will kick in first, having a chance to resolve an argument value before the standard argument handling kicks in.

    - #### setCustomArgumentResolvers

          public void setCustomArgumentResolvers(WebArgumentResolver[] argumentResolvers)

      Deprecated.
      Set one or more custom ArgumentResolvers to use for special method parameter types.

      Any such custom ArgumentResolver will kick in first, having a chance to resolve an argument value before the standard argument handling kicks in.

    - #### setMessageConverters

          public void setMessageConverters(HttpMessageConverter<?>[] messageConverters)

      Deprecated.
      Set the message body converters to use.

      These converters are used to convert from and to HTTP requests and responses.

    - #### doResolveException

          protected ModelAndView doResolveException(HttpServletRequest request,
                                        HttpServletResponse response,
                                        Object handler,
                                        Exception ex)

      Deprecated.
      Description copied from class: `AbstractHandlerExceptionResolver`
      Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.

      May be overridden in subclasses, in order to apply specific exception checks. Note that this template method will be invoked after checking whether this resolved applies ("mappedHandlers" etc), so an implementation may simply proceed with its actual exception handling.

      Specified by:
        `doResolveException` in class `AbstractHandlerExceptionResolver`
      Parameters:
        `request` - current HTTP request
        `response` - current HTTP response
        `handler` - the executed handler, or `null` if none chosen at the time of the exception (for example, if multipart resolution failed)
        `ex` - the exception that got thrown during handler execution
      Returns:
        a corresponding ModelAndView to forward to, or `null` for default processing

    - #### getHandledExceptions

          protected List<Class<? extends Throwable>> getHandledExceptions(Method method)

      Deprecated.
      Returns all the exception classes handled by the given method.

      The default implementation looks for exceptions in the annotation, or - if that annotation element is empty - any exceptions listed in the method parameters if the method is annotated with `@ExceptionHandler`.

      Parameters:
        `method` - the method
      Returns:
        the handled exceptions

    - #### resolveCommonArgument

          protected Object resolveCommonArgument(MethodParameter methodParameter,
                                     NativeWebRequest webRequest,
                                     Exception thrownException)
                                          throws Exception

      Deprecated.
      Resolves common method arguments. Delegates to registered `argumentResolvers` first, then checking `resolveStandardArgument(java.lang.Class<?>, org.springframework.web.context.request.NativeWebRequest, java.lang.Exception)`.
      Parameters:
        `methodParameter` - the method parameter
        `webRequest` - the request
        `thrownException` - the exception thrown
      Returns:
        the argument value, or `WebArgumentResolver.UNRESOLVED`
      Throws:
        `Exception`

    - #### resolveStandardArgument

          protected Object resolveStandardArgument(Class<?> parameterType,
                                       NativeWebRequest webRequest,
                                       Exception thrownException)
                                            throws Exception

      Deprecated.
      Resolves standard method arguments. The default implementation handles `NativeWebRequest`, `ServletRequest`, `ServletResponse`, `HttpSession`, `Principal`, `Locale`, request `InputStream`, request `Reader`, response `OutputStream`, response `Writer`, and the given `thrownException`.
      Parameters:
        `parameterType` - the method parameter type
        `webRequest` - the request
        `thrownException` - the exception thrown
      Returns:
        the argument value, or `WebArgumentResolver.UNRESOLVED`
      Throws:
        `Exception`